-- Configuration file for ESP-ISEMS-nodeid

-- Lines beginning with two dashes (--) are comments.
-- BEGIN
------ Battery and Solar Module
-- Rated capacity of battery in Ampere hours (Ah)
battah=200

-- Rated power rating of the solar module in Watt.
solarwp=200

-- Average power consumption of the system in Ampere (A)
avrpwrcns=4
------ WIFI
-- WiFi mode
-- One of: 1 = STATION, 2 = SOFTAP, 3 = STATIONAP, 4 = NULLMODE
wmode=2 -- option 1;2;3;4

---- Station
-- Wifi station AP SSID (Connect to a local Internet hotspot.)
stssid="OpenWrt"

-- WPA key
stpwd="" --password

-- Station hostname (optional)
sthstnm="OMPPTSENS"

---- Accesspoint
-- Note: Always provide a AP configuration here.
-- If the OpenMPPT can not connect in STATION only
-- mode, it will use these AP settings as fallback. 
-- Accesspoint SSID
apssid="OpenMPPT"

-- Accesspoint WPA key (can not be blank, default 12345678)
appwd="12345678" -- password

-- Accesspoint WiFi channel
apchn="9"

-- Accesspoint IP
apip="192.168.10.10"

-- Accesspoint Netmask
apnmsk="255.255.255.0"

-- Internet gateway IP
apgw="192.168.10.10"

-- DNS server IP
apdns="8.8.8.8"

-- Accesspoint hostname (leave blank for default)
aphstnm="OpenMPPT-AP"

------ System
-- Password for ftp,telnet and web
-- Beware: Passwords are send unencrypted.
webkey="pass123" -- password

-- Autoreboot timer in minutes
-- The device will reboot after N minutes.
-- Set N to 0 to disable.
nextreboot=3600

-- Local timezone. 
timezone="CEST-1"


-- Latitude of Geolocation
lat=52.52

-- Longitude of Geolocation
long=13.4

-- Node-ID (used in telemetry and csv log)
nodeid="OMPPTSENS"

-- Nodemcu internal debugging output.
-- Enable only to debug FreeRTOS.
osprint=0 -- option 0;1

-- Lua program debug level. From 0 (critical errors only) up to 4 (very verbose)
verbose=1 -- option 1;2;3;4

-- Optional ds18b20 I2C temperature sensor connected to GPIO21
ow18b20=0 -- option 0;1

------ MQTT
-- Enable MQTT?
mqttnbld=1 -- option 0;1
---- MQTT broker to connect to
brkr1hst="api.isems.de"
-- Port
brkr1prt=1883
-- MQTT channel 
brkr1chan="/isems/"
-- Close connection after transmission?
-- Recommended if using 2 brokers.
brkr1cls=1 -- option 0;1
-- Send only last CSV data entry?
-- If set to 0, the last 5 CSV entries are send.
brkr1shrt=0 -- option 0;1
-- Send JSON formatted data instead of CSV?
brkr1jsn=0 -- option 0;1

---- Second MQTT broker (optional, leave blank to disable)
brkr2hst="isems.mqtthub.net"
-- Port
brkr2prt=1883
-- MQTT channel
-- Note: mqtthub.net doesn't like "/" 
-- at the beginning of the channel 
brkr2chan="isems/testdrive/foobar/"
-- Close connection after transmission?
-- Recommended if using 2 brokers.
brkr2cls=1 -- option 0;1
-- Send only last CSV data entry?
brkr2shrt=0 -- option 0;1
-- Send JSON data instead of CSV?
brkr2jsn=1 -- option 0;1

------ SENSORS
-- Enable SENSORS?
-- 0=disabled, 1=BME280+SDS011, 2=BME280+SPS30
snsrs=0 -- option 0;1;2
-- If MQTT with JSON format is enabled, sensor telemetry is shared via MQTT
-- Share with other sensor data servers?
-- 0=disabled, 1=sensor.community (requires online registration), 2=api-rrd.madavi.de
snscmnty=0 -- option 0;1;2
-- Sum up or differentiate particle mass/count data
-- for each particle size range (more nerdy :)
-- 0=sum up (default for most sensor communities)
-- 1=differentiate for each particle size range (more nerdy :)
snsdiff=0 -- option 0;1

--
--



