
if not uartenabled or uartenabled == false then 
uart.setup(2, 115200, 8, uart.PARITY_NONE, uart.STOPBITS_1, {rx = 16, tx = 17})
uart.start(2)
uartenabled = true
end

counter = 0 
shdlc = {}


function hexdecode(hex)
   return (hex:gsub("%x%x", function(digits) return string.char(tonumber(digits, 16)) end))
end


function hexencode(str)
   return (str:gsub(".", function(char) return string.format("%2x", char:byte()) end))
end


function spsstart()
-- Start measurement
uart.write(2, 0x7E, 0x00, 0x00, 0x02, 0x01, 0x05, 0xF7, 0x7E)
end

function spsstop()
-- Stop measurement 
uart.write(2, 0x7E, 0x00, 0x01, 0x00, 0xFE, 0x7E)
end

function spsread()
-- Read measurement results
uart.write(2, 0x7E, 0x00, 0x03, 0x00, 0xFC, 0x7E)
end

function spssleep()
-- Go to powersaving sleep mode
uart.write(2, 0x7E, 0x00, 0x10, 0x00, 0xEF, 0x7E)
end

function spswakeup()
-- Wake up from powersaving sleep mode
uart.write(2, 0xFF)
spsidle()
end

function spsidle()
-- Activate powersaving idle mode
uart.write(2, 0x7E, 0x00, 0x11, 0x00, 0xEE, 0x7E)
end

function spsfanclean()
-- Run fan full speed for 10 seconds
uart.write(2, 0x7E, 0x00, 0x56, 0x00, 0xA9, 0x7E)
end


function spsreset()
-- Soft-reset device like a power reset
uart.write(2, 0x7E, 0x00, 0xD3, 0x00, 0x2C, 0x7E)
end

function spsshowdevstatusregister()
-- Read and delete device status register
uart.write(2, 0x7E, 0x00, 0xD2, 0x00, 0x00, 0x2C, 0x7E)
end

function spsinfo()
-- Print productinfo
uart.write(2, 0x7E, 0x00, 0xD1, 0x00, 0x2E, 0x7E)
end

uart.on(2, "data",0,
  function(data)
    printv(4,"Response from SPS30: 0x",hexencode(data))
    if hexencode(data) == "7e" and counter == 0 then counter = 1 shdlc[counter] = data  end
    if hexencode(data) ~= "7e" then counter=counter+1 shdlc[counter]=data end
    
    if hexencode(shdlc[counter-1]) == "7d" and hexencode(shdlc[counter]) == "5e" then shdlc[counter-1] = hexdecode("7e") counter = counter -1 end
    if hexencode(shdlc[counter-1]) == "7d" and hexencode(shdlc[counter]) == "5d" then shdlc[counter-1] = hexdecode("7d") counter = counter -1 end
    if hexencode(shdlc[counter-1]) == "7d" and hexencode(shdlc[counter]) == "31" then shdlc[counter-1] = hexdecode("11") counter = counter -1 end
    if hexencode(shdlc[counter-1]) == "7d" and hexencode(shdlc[counter]) == "33" then shdlc[counter-1] = hexdecode("13") counter = counter -1 end
    
    if hexencode(data) == "7e" and counter > 1 then counter=counter+1 shdlc[counter]=data  maxcounter=counter counter = 0
    for i=1,maxcounter do printv(4,i, hexencode(shdlc[i])) end
    printv(4,"Maxcounter", maxcounter)
    
   if maxcounter == 27 then 
   MassConcentrationPM1 = (tonumber(hexencode(shdlc[6]),16) * 256) + tonumber(hexencode(shdlc[7]),16) printv(4,"MassConcentrationPM1 =",MassConcentrationPM1) 
   MassConcentrationPM2d5 = (tonumber(hexencode(shdlc[8]),16) * 256) + tonumber(hexencode(shdlc[9]),16) printv(4,"MassConcentrationPM2d5 =",MassConcentrationPM2d5)
   MassConcentrationPM4 = (tonumber(hexencode(shdlc[10]),16) * 256) + tonumber(hexencode(shdlc[11]),16) printv(4,"MassConcentrationPM4 =",MassConcentrationPM4)
   MassConcentrationPM10 = (tonumber(hexencode(shdlc[12]),16) * 256) + tonumber(hexencode(shdlc[13]),16) printv(4,"MassConcentrationPM10 =",MassConcentrationPM10)
   NumberConcentrationPM05 = (tonumber(hexencode(shdlc[14]),16) * 256) + tonumber(hexencode(shdlc[15]),16) printv(4,"NumberConcentrationPM05 =",NumberConcentrationPM05)
   NumberConcentrationPM1 = (tonumber(hexencode(shdlc[16]),16) * 256) + tonumber(hexencode(shdlc[17]),16) printv(4,"NumberConcentrationPM1 =",NumberConcentrationPM1)
   NumberConcentrationPM2d5 = (tonumber(hexencode(shdlc[18]),16) * 256) + tonumber(hexencode(shdlc[19]),16) printv(4,"NumberConcentrationPM2d5 =",NumberConcentrationPM2d5)
   NumberConcentrationPM4 = (tonumber(hexencode(shdlc[20]),16) * 256) + tonumber(hexencode(shdlc[21]),16) printv(4,"NumberConcentrationPM4 =",NumberConcentrationPM4)
   NumberConcentrationPM10 = (tonumber(hexencode(shdlc[22]),16) * 256) + tonumber(hexencode(shdlc[23]),16) printv(4,"NumberConcentrationPM10 =",NumberConcentrationPM10)
   TypicalParticleSizeNm  = (tonumber(hexencode(shdlc[24]),16) * 256) + tonumber(hexencode(shdlc[25]),16) printv(4,"TypicalParticleSizeNm =",TypicalParticleSizeNm)
   end
   end
    
    
    end)
  
-- error handler
uart.on(2, "error",
  function(data)
    printv(1,"error from uart2:", data)
  end)
